<?php
/*
This file should store all future installation-specific variables for use by
COMMENCE. Care should be taken to ensure global variables do not overlap with
code elsewhere.

It would be helpful if a description of what the variable is actually used for
is included too.
*/

/*
This section should contain any helper enumerations or values. These should
be constants and not vary during runtime.
*/

$COMMENCE_DATE_FORMAT_TYPES = array();
$COMMENCE_DATE_FORMAT_TYPES["IS0 8601"]          = "Y-m-d";
$COMMENCE_DATE_FORMAT_TYPES["US"]                = "M j Y";
$COMMENCE_DATE_FORMAT_TYPES["US Dashed"]         = "M-d-Y";
$COMMENCE_DATE_FORMAT_TYPES["European"]          = "j M Y";
$COMMENCE_DATE_FORMAT_TYPES["European Dashed"]   = "d-M-Y";
$COMMENCE_DATE_FORMAT_TYPES["European with Day"] = "D, j M Y";
$COMMENCE_DATE_FORMAT_TYPES["Long US"]           = "l, F jS, Y";
$COMMENCE_DATE_FORMAT_TYPES["Long European"]     = "l, j F Y";

?>
<?php
/*
Any variables that are alterable by "preferences.php" using the install process
should be included here.
*/
$PREFERENCE_VARS = array(
    "DB_HOSTNAME",
    "DB_DATABASE",
    "DB_USERNAME",
    "DB_PASSWORD",
    "DB_PREFIX"
);
/*
This section should contain default values for variables which either need to be
added quickly, or are unlikely to vary. SESUG additions should start here, then
work their way into Settings.
*/
// Database connection
$DB_HOSTNAME = "localhost";
$DB_DATABASE = "commence";
$DB_USERNAME = "";
$DB_PASSWORD = "";
$DB_PREFIX   = "";

// Labels
$TRACK_NAME = "Track"; // Name of the "Track" concept
$TOPIC_NAME = "Topic"; // Name of the "Topic" concept

$PRIMARY_EMAIL_NAME = "Email (Primary)";
$SECONDARY_EMAIL_NAME = "Email (Secondary)";
$PRIMARY_PHONE_NAME = "Phone (Primary)";
$SECONDARY_PHONE_NAME = "Phone (Secondary)";

$attended = "SESUGs Attended";
$presented = "SESUGs Presented";
$keyword = "Additional Keyword";

/* Export vars */
$PREFERENCE_VARS = compact($PREFERENCE_VARS);
?>
<?php 
/*
Actual site preferences are not stored in this file, but in "preferences.php",
which is generated by the installation process.
*/

if (file_exists("$php_root_path/includes/preferences.php"))
	require_once("$php_root_path/includes/preferences.php");

?>
